'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _nedb = require('nedb');

var _nedb2 = _interopRequireDefault(_nedb);

var _log = require('./log');

var log = _interopRequireWildcard(_log);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function threadID(post) {
  while (post.level > 0) {
    post = post.parent;
  }
  return post.id;
}

var DB = (function () {
  function DB(filename) {
    _classCallCheck(this, DB);

    this.db = new _nedb2.default({
      filename: filename,
      autoload: true
    });
  }

  _createClass(DB, [{
    key: 'touchVersion',
    value: function touchVersion(post) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var query = { graphID: post.id };

        _this.db.findOne(query, function (err, doc) {
          if (err) {
            reject(err);
          } else if (doc != null && post.version === doc.version) {
            resolve(false);
          } else {
            _this.db.update(query, { graphID: post.id, version: post.version }, { upsert: true }, function (err, _, newDoc) {
              if (err) {
                reject(err);
              } else {
                resolve(newDoc == null ? 'edit' : 'new');
              }
            });
          }
        });
      });
    }
  }, {
    key: 'threadStateObj',
    value: function threadStateObj(post) {
      var _this2 = this;

      var thread = threadID(post);
      return {
        get: function get() {
          return _this2.getThreadState(thread);
        },
        set: function set(s) {
          return _this2.setThreadState(thread, s);
        },
        update: function update(s) {
          return _this2.updateThreadState(thread, s);
        }
      };
    }
  }, {
    key: 'getThreadState',
    value: function getThreadState(thread) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        _this3.db.findOne({ thread: thread }, function (err, doc) {
          if (err) {
            reject(err);
          } else if (doc == null) {
            log.debug('get thread state', { thread: thread, state: {} });
            resolve({});
          } else {
            log.debug('get thread state', { thread: thread, state: doc.state });
            resolve(doc.state);
          }
        });
      });
    }
  }, {
    key: 'setThreadState',
    value: function setThreadState(thread, state) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        _this4.db.update({ thread: thread }, { thread: thread, state: state }, { upsert: true }, function (err, _, newDoc) {
          if (err) {
            reject(err);
          } else {
            log.debug('set thread state', thread, state);
            resolve();
          }
        });
      });
    }
  }, {
    key: 'updateThreadState',
    value: function updateThreadState(thread, updates) {
      var _this5 = this;

      return this.getThreadState(thread).then(function (s) {
        var newState = Object.assign({}, s, updates);
        return _this5.setThreadState(thread, newState);
      });
    }
  }]);

  return DB;
})();

exports.default = DB;