"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (interval, fn, onError) {

  onError = onError ? onError : function () {};

  var ready = true;
  var refresh = function refresh() {

    if (!ready) {
      return;
    }
    ready = false;

    try {

      var p = fn();
      if (p == null) {
        ready = true;
      } else {
        p.then(function () {
          ready = true;
        }).catch(function (err) {
          onError(err);
          ready = true;
        });
      }
    } catch (err) {
      onError(err);
      ready = true;
    }
  };

  refresh();
  return setInterval(function () {
    return refresh();
  }, interval);
};